<?php
/*##################################################
 *                        content_xmlhttprequest.php
 *                            -------------------
 *   begin                : January, 25 2007
 *   copyright            : (C) 2007 Viarre Rgis
 *   email                : crowkait@phpboost.com
 *
 *
 ###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 ###################################################*/
/**
* @package ajax
*
*/

define('PATH_TO_ROOT', '../../..');
define('NO_SESSION_LOCATION', true); //Permet de ne pas mettre jour la page dans la session.

include_once(PATH_TO_ROOT . '/kernel/begin.php');
include_once(PATH_TO_ROOT . '/kernel/header_no_display.php');

$page_path_to_root = retrieve(REQUEST, 'path_to_root', '');
$page_path = retrieve(REQUEST, 'page_path', '');

//Quel diteur utiliser ? Si ce n'est pas prcis on prend celui par dfaut de l'utilisateur
$editor = retrieve(REQUEST, 'editor', $CONFIG['editor']);

$contents = utf8_decode(retrieve(POST, 'contents', '', TSTRING_AS_RECEIVED));

$ftags = retrieve(POST, 'ftags', TSTRING_UNCHANGE);
$forbidden_tags = explode(',', $ftags);

//On prend le bon parseur avec la bonne configuration
$content_manager = new ContentFormattingFactory($editor);
$parser = $content_manager->get_parser($editor);

$parser->set_content($contents, MAGIC_QUOTES);
$parser->set_path_to_root($page_path_to_root);
$parser->set_page_path($page_path);

if (!empty($forbidden_tags))
{
    $parser->set_forbidden_tags($forbidden_tags);
}

$parser->parse();

//On parse la deuxime couche (code, math etc) pour afficher
$second_parser = $content_manager->get_second_parser();
$second_parser->set_content($parser->get_content(DO_NOT_ADD_SLASHES), PARSER_DO_NOT_STRIP_SLASHES);
$second_parser->set_path_to_root($page_path_to_root);
$second_parser->set_page_path($page_path);

$second_parser->parse();

$contents = $second_parser->get_content(DO_NOT_ADD_SLASHES);

echo $contents;

include_once(PATH_TO_ROOT . '/kernel/footer_no_display.php');

?>